const requestify = require('requestify');

class HttpClient {

	constructor (defaultHeaders) {
		this.defaultHeaders = defaultHeaders;
	}

	buildOptions (options) {
		options.headers = Object.assign({}, this.defaultHeaders, options.headers);
		return options;
	}

	request (url, options = {}) {
		return requestify.request(url, this.buildOptions(options));
	}

	get (url, options = {}) {
		return requestify.get(url, this.buildOptions(options));
	}

	post (url, data, options = {}) {
		return requestify.post(url, data, this.buildOptions(options));
	}

	put (url, data, options = {}) {
		return requestify.put(url, data, this.buildOptions(options));
	}

	delete (url, options = {}) {
		return requestify.delete(url, this.buildOptions(options));
	}

	head (url, options = {}) {
		return requestify.head(url, this.buildOptions(options));
	}
} 

module.exports = HttpClient;
