const getRequestMetadata = req => {
  const config = {};

  config.serverIP = req.connection.localAddress;
  config.serverPort = req.connection.localPort.toString();
  config.clientIP = req.connection.remoteAddress;
  config.clientPort = req.connection.remotePort.toString();
  config.contractorId = req.contractor_id;
  config.user = req.user;

  return config;
};

const getResponseBody = (res, body) => {
    const oldWrite = res.write;
    const oldEnd = res.end;
    const chunks = [];

    return new Promise((resolve, reject) => {
        res.write = function (chunk) {
            chunks.push(new Buffer(chunk));
            oldWrite.apply(res, arguments);
        };

        res.end = function (chunk) {
            if (chunk) {
                chunks.push(new Buffer(chunk));
            }

            body = Buffer.concat(chunks).toString('utf8');

            resolve(body);
            oldEnd.apply(res, arguments);
        };
    });
};

module.exports = {
    getRequestMetadata,
    getResponseBody
};
