const requestify = require('requestify');
const config = require('../config');
const get = require('lodash').get;

const getByDescription = (contractorId, description) => {
    const url = `http://${config.host}/logs/type`;
    const filter = `filter.description=${description}`;
    const options = {
        headers: { 'x-contractor-id': contractorId }
    };

    return requestify.get(`${url}?${filter}`, options)
        .then(response => {
            const body = response.getBody();
            return get(body, 'data.items[0]', null);
        });
};

module.exports = {
    getByDescription
};
